Jak bezpečně odebrat USB disk 

Chcete-li od počítače odpojit USB disk, obvykle stačí odmountovat připojený oddíl a vytáhnout USB zařízení, ale není to úplně ono. Disk je do poslední chvíle přístupný operačnímu systému a ani USB řadič v disku neví, že by se chystalo nějaké odpojení. Když takovéto vytažení provedete Nokia telefonu v režimu mass storage, vynadá vám telefon, že mohlo dojít k poškození dat. Není to nic fatálního, pokud je oddíl odmountován, k poškození dat nedojde, ale stejně se mi to nelíbí.
Co tedy dalšího je vhodné udělat před odpojením USB disku?

Především můžeme USB zařízení uspat. V jádře s podporou USB_SUSPEND až do verze 2.6.32 to šlo udělat jednoduše zapsáním:
# echo suspend > /sys/bus/usb/devices/<BUS-ID>/power/level
kde za <BUS-ID> je třeba doplnit správné USB ID (např 5-2). Jenže tohle už nejde. Od jádra 2.6.32 je vynucené suspendování zrušeno a je možné spoléhat pouze na autosuspend, tedy že kernel automaticky zařízení uspí, bude-li nečinné. Jenže stačí zaregistrování blokového zařízení modulem usb_storage, a zařízení je pro kernel v činnosti.

Řešením by mohlo být odebrání modulu usb_storage. To s sebou ovšem veze neblahý vedlejší efekt ve ztrátě všech USB disků. Je ale možné i odpojit konkrétní zařízení, opět přes sysfs:
# echo <BUS-ID> > /sys/bus/usb/drivers/usb/unbind

Pak stačí nastavit automatický spánek s délkou timeoutu na nula:
# echo 0 > /sys/bus/usb/devices/<BUS-ID>/power/autosuspend
# echo auto > /sys/bus/usb/devices/<BUS-ID>/power/level

V tuto chvíli by mělo být zařízení z hlediska USB sběrnice uspáno a odebrání by mělo být opravdu bezpečné. Pokud však jde o klasický rotační hard-disk, je možné že i po uspání USB se stále otáčí, což by nemusel. V takovém případě by mohlo pomoci poslat ještě před odpojením disku SCSI příkaz STOP, třeba pomocí utility sdparm. V mém případě to ale stejně nefungovalo.
[more]
Na samý závěr je vhodné proces zautomatizovat. To už naštěstí udělal za mě Yan Li. Já jsem skript jen upravil pro nové jádro a zakomentoval příkazy sdparm, které mi stejně nefungovaly a navíc ve spojení s Nokií vytuhly. Mojí upravenou verzi najdete přímo zde v článku (jsem líný vytvářet přílohu :) ):

#!/bin/bash
#
# suspend-usb-device: an easy-to-use script to properly put an USB
# device into suspend mode that can then be unplugged safely
#
# Copyright (C) 2009, Yan Li <elliot.li.tech@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
# To reach the auther, please write an email to the address as stated
# above.

# ACKNOWLEDGEMENTS:
# Christian Schmitt <chris@ilovelinux.de> for firewire supporting
# David <d.tonhofer@m-plify.com> for improving parent device
# search and verbose output message


usage()
{
cat<<EOF
suspend-usb-device Copyright (C) 2009 Yan Li <elliot.li.tech@gmail.com>

This script is designed to properly put an USB device into suspend
mode that can then be unplugged safely. It sends a SYNCHRONIZE CACHE
command followed by a START-STOP command (if the device supports it),
unbinds the device from the driver and then suspends the USB
port. After that you can disconnect your USB device safely.

usage:
$0 [options] dev

sample:
$0 /dev/sde

options:
-l show the device and USB bus ID only
-h print this usage
-v verbose

This program comes with ABSOLUTELY NO WARRANTY. This is free
software, and you are welcome to redistribute it under certain
conditions; for details please read the licese at the beginning of the
source code file.
EOF
}

set -e -u

SHOW_DEVICE_ONLY=0
VERBOSE=0
while getopts "vlh" opt; do
case "$opt" in
h)
usage
exit 2
;;
l)
SHOW_DEVICE_ONLY=1
;;
v)
VERBOSE=1
;;
?)
echo
usage
exit 2
;;
esac
done
DEV_NAME=${!OPTIND:-}

if [ -z ${DEV_NAME} ]; then
usage
exit 2
fi

# mount checking
if mount | grep "^${DEV_NAME}[[:digit:]]* "; then
1>&2 echo
1>&2 echo "the above disk or partition is still mounted, can't suspend device"
1>&2 echo "unmount it first using umount"
exit 1
fi

# looking for the parent of the device with type "usb-storage:usb", it
# is the grand-parent device of the SCSI host, and it's devpath is
# like
# /devices/pci0000:00/0000:00:1d.7/usb5/5-8 (or /fw5/fw5-8 for firewire devices)

# without an USB hub, the device path looks like:
# /devices/pci0000:00/0000:00:1d.7/usb2/2-1/2-1:1.0/host5/target5:0:0/5:0:0:0
# here the grand-parent of host5 is 2-1

# when there's a USB HUB, the device path is like:
# /devices/pci0000:00/0000:00:1d.0/usb5/5-2/5-2.2/5-2.2:1.0/host4/target4:0:0/4:0:0:0
# and the grand-parent of host4 is 5-2.2

DEVICE=$(udevadm info --query=path --name=${DEV_NAME} --attribute-walk | \
egrep "looking at parent device" | head -1 | \
sed -e "s/.*looking at parent device '\(\/devices\/.*\)\/.*\/host.*/\1/g")

if [ -z $DEVICE ]; then
1>&2 echo "cannot find appropriate parent USB/Firewire device, "
1>&2 echo "perhaps ${DEV_NAME} is not an USB/Firewire device?"
exit 1
fi

# the trailing basename of ${DEVICE} is DEV_BUS_ID ("5-8" in the
# sample above)
DEV_BUS_ID=${DEVICE##*/}

[[ $VERBOSE == 1 ]] && echo "Found device $DEVICE associated to $DEV_NAME; USB bus id is $DEV_BUS_ID"

if [ ${SHOW_DEVICE_ONLY} -eq 1 ]; then
echo Device: ${DEVICE}
echo Bus ID: ${DEV_BUS_ID}
exit 0
fi

# flush all buffers
sync

# root check
if [ `id -u` -ne 0 ]; then
1>&2 echo error, must be run as root, exiting...
exit 1
fi


# send SCSI sync command, some devices don't support this so we just
# ignore errors with "|| true"
[[ $VERBOSE == 1 ]] && echo "Syncing device $DEV_NAME"
#sdparm --command=sync "$DEV_NAME" >/dev/null || true
# send SCSI stop command
[[ $VERBOSE == 1 ]] && echo "Stopping device $DEV_NAME"
#sdparm --command=stop "$DEV_NAME" >/dev/null

# unbind it; if this yields "no such device", we are trying to unbind the wrong device
[[ $VERBOSE == 1 ]] && echo "Unbinding device $DEV_BUS_ID"
if [[ "${DEV_BUS_ID}" == fw* ]]
then
echo -n "${DEV_BUS_ID}" > /sys/bus/firewire/drivers/sbp2/unbind
else
echo -n "${DEV_BUS_ID}" > /sys/bus/usb/drivers/usb/unbind

# suspend it if it's an USB device (we have no way to suspend a
# firewire device yet)

# check if CONFIG_USB_SUSPEND is enabled
[[ $VERBOSE == 1 ]] && echo "Checking whether $DEVICE can be suspended"
POWER_LEVEL_FILE=/sys${DEVICE}/power/level
if [ ! -f "$POWER_LEVEL_FILE" ]; then
1>&2 cat<<EOF
It's safe to remove the USB device now but better can be done. The
power level control file $POWER_LEVEL_FILE
doesn't exist on the system so I have no way to put the USB device
into suspend mode, perhaps you don't have CONFIG_USB_SUSPEND enabled
in your running kernel.

Read
http://elliotli.blogspot.com/2009/01/sa ... linux.html
for an detailed explanation.
EOF
exit 3
fi

[[ $VERBOSE == 1 ]] && echo "Suspending $DEVICE by writing to $POWER_LEVEL_FILE"
echo 0 > "/sys${DEVICE}/power/autosuspend"
echo 'auto' > "$POWER_LEVEL_FILE"
fi

tubicoid 

ja pouzivam toto, funguje na USB i SATA, e-SATA,
asi to udela to samy, co eject

echo 1 > /sys/block/sde/device/delete
Franta 

Mně funguje docela obyčejné:
eject /dev/sdb
a disk se přestane točit.

Komentáře

Pro tento záznam nejsou komentáře povoleny.